View Issue Details

IDProjectCategoryView StatusLast Update
0015075LazarusLCLpublic2011-12-01 11:22
ReporterPaul van HeldenAssigned ToFelipe Monteiro de Carvalho 
PrioritynormalSeveritycrashReproducibilityalways
Status closedResolutionfixed 
Product Version0.9.28Product Build 
Target VersionFixed in Version0.9.29 (SVN) 
Summary0015075: Exception handling not working on ARM-WinCE
DescriptionA trivial app with Exception.Create('Hallo world') crashes at line 1514 of LCLProc.pas with RunError(6):

  DebugLn(BackTraceStrFunc(ExceptAddr));

So, no exceptions are ever seen by the user. The app simply terminates.
Additional InformationThis looks like a FPC problem as the error occurs within SysBackTraceStr.

Temporary solution: comment out DumpExceptionBackTrace at lines 1092 & 1097 in application.inc

This happens even with DebugLn not producing output.

Suggestion: DumpExceptionBackTrace should terminate immediately if no debug output are to be produced. (Same as DebugLn).
TagsNo tags attached.
Fixed in Revision22722, 22725, 22775. 22786
LazTarget-
WidgetsetWinCE
Attached Files

Relationships

related to 0014330 new FPC -gl causes LCL WinCE application to crash on unhandled exception 

Activities

Sven Barth

2009-11-13 17:57

manager   ~0032124

Seems to be the same as 0014330

@Reporter: As a workaround: compile without -gl or set BackTraceToStr in your application to SysBackTraceToStr.

Felipe Monteiro de Carvalho

2009-11-23 14:52

developer   ~0032383

I fixed from the LCL point of view, the other report can be used to track the FPC problem. To solve it I added a new define in the LCL:

http://wiki.lazarus.freepascal.org/LCL_Defines#General_LCL_defines

Without DEBUG_ALLOW_DUMPBACKTRACE no backtrace dumping is ever performed.

Vincent Snijders

2009-11-23 16:20

manager   ~0032389

> Without DEBUG_ALLOW_DUMPBACKTRACE no backtrace dumping is ever performed.

And that is bad, why hurt the error reporting on *all* platforms, if only the reporting on wince is broken.

Vincent Snijders

2009-11-23 16:21

manager   ~0032390

I propose to revert this change and disable the calling the backtrace function for wince only, until issue 14330 has been fixed.

Vincent Snijders

2009-11-26 08:25

manager   ~0032486

I implemented the workaround mentioned by Sven Barth in r22786.

Issue History

Date Modified Username Field Change
2009-11-13 12:18 Paul van Helden New Issue
2009-11-13 12:18 Paul van Helden Widgetset => WinCE
2009-11-13 17:57 Sven Barth Note Added: 0032124
2009-11-13 18:18 Felipe Monteiro de Carvalho Status new => assigned
2009-11-13 18:18 Felipe Monteiro de Carvalho Assigned To => Felipe Monteiro de Carvalho
2009-11-13 19:35 Vincent Snijders Relationship added related to 0014330
2009-11-23 14:52 Felipe Monteiro de Carvalho Fixed in Revision => 22722
2009-11-23 14:52 Felipe Monteiro de Carvalho LazTarget => -
2009-11-23 14:52 Felipe Monteiro de Carvalho Status assigned => resolved
2009-11-23 14:52 Felipe Monteiro de Carvalho Fixed in Version => 0.9.29 (SVN)
2009-11-23 14:52 Felipe Monteiro de Carvalho Resolution open => fixed
2009-11-23 14:52 Felipe Monteiro de Carvalho Note Added: 0032383
2009-11-23 16:20 Vincent Snijders Note Added: 0032389
2009-11-23 16:21 Vincent Snijders Status resolved => assigned
2009-11-23 16:21 Vincent Snijders Resolution fixed => reopened
2009-11-23 16:21 Vincent Snijders Note Added: 0032390
2009-11-25 19:07 Felipe Monteiro de Carvalho Fixed in Revision 22722 => 22722, 22725, 22775
2009-11-25 19:07 Felipe Monteiro de Carvalho Status assigned => resolved
2009-11-25 19:07 Felipe Monteiro de Carvalho Resolution reopened => fixed
2009-11-26 08:25 Vincent Snijders Fixed in Revision 22722, 22725, 22775 => 22722, 22725, 22775. 22786
2009-11-26 08:25 Vincent Snijders Note Added: 0032486
2011-12-01 11:22 Marc Weustink Status resolved => closed